using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class _Default : System.Web.UI.Page
{
    //Instancia o objeto de paginao
    PagedDataSource pgds = new PagedDataSource();

    // Seta o numero total de paginas que sero exibidas na paginao
    int totalpaginas = 7;

    //Inicia em 3 para a primeira pagina, representa a diferena entre a numerao das paginas
    int numerop = 3;

    int pagina;

    int numeropaginas;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            //grava no ViewState pagina a primeira pagina da paginao e o numero total de paginas
            ViewState["pagina"] = 0;
            ViewState["numeropaginas"] = totalpaginas;
        }
        FillDados();
    }
    private void FillDados()
    {
        // Preenche uma lista de objetos para servirem de dataSource do nosso repeater.
        //(Essa lista de objetos pode ser consumida por um dataset por exemplo) 
        List<Dados> lst = new List<Dados>();
        for (int i = 0; i < 200; i++)
        {
            Dados dados = new Dados();
            dados.Descricao = "Registro " + i.ToString();
            lst.Add(dados);
        }

        pagina = Convert.ToInt32(ViewState["pagina"]);
        numeropaginas = Convert.ToInt32(ViewState["numeropaginas"]);

        
        //Seta a fonte de dados do objeto de paginao como a nossa lista de objetos
        pgds.DataSource = lst;

        //Permite a paginao do objeto
        pgds.AllowPaging = true;

        //Seta a pagina atual do objeto como sendo nosso ViewState de pagina.
        pgds.CurrentPageIndex = pagina;

        //Seta a quantidade de registros por pgina
        pgds.PageSize = 5;

        //Aqui eu limpo os controles da minha div para acrecentar novamente a numeo
        paginas.Controls.Clear();

        //Utilizado para as primeiras pginas, pois nas primeiras pginas a numerao da paginao no se altera,
        if (pagina < numerop)
        {
            int cont = 0;
            while (cont < numerop)
            {
                int p = pagina;
                if (p == cont)
                {
                    numerop = p;
                    break;
                }
                cont++;
            }
        }

        //Percorre do viewstate pagina menos o numero setado para os nmeros anteriores a pagina atual at o viewstate numero de pgina
        for (int i = pagina - numerop; i <= numeropaginas - 1; i++)
        {

            if (numeropaginas > totalpaginas)
            {
                //Caso exista outra paginao anterior, ou seja, no sejam os primeiros nmeros na exibio.
                if (i == numeropaginas - totalpaginas)
                {
                    //Adiciona o link buttom ... para voltar para as primeiras pginas
                    LinkButton lb2 = new LinkButton();
                    lb2.Text = "...";
                    lb2.ID = "...ant";
                    lb2.Command += new CommandEventHandler(PrimeiraPagina);
                    paginas.Controls.Add(lb2);
                    Label lbl = new Label();
                    lbl.Text = " ";
                    paginas.Controls.Add(lbl);
                }
            }
            LinkButton lb = new LinkButton();
            if (i == pgds.CurrentPageIndex)
            {
                lb.Text = "[" + (i + 1).ToString() + "]";
            }
            else
            {
                lb.Text = (i + 1).ToString();
            }
            lb.ID = i.ToString();
            lb.CommandName = i.ToString();
            lb.Command += new CommandEventHandler(Paginar);
            paginas.Controls.Add(lb);
            Label lbl2 = new Label();
            lbl2.Text = " ";
            paginas.Controls.Add(lbl2);

            //Caso no seja a ultima numerao a ser exibida
            if (numeropaginas < pgds.PageCount)
            {
                if (i == numeropaginas - 1)
                {
                    //Adiciona o Link Buttom ... para ir para as ultimas pginas da paginao.
                    LinkButton lb2 = new LinkButton();
                    lb2.Text = "...";
                    lb2.ID = "...prox";
                    lb2.Command += new CommandEventHandler(UltimaPagina);
                    paginas.Controls.Add(lb2);
                }
            }
        }

        //Seta a visibilidade do boto proximo e anterior de acordo com a primeira ou ultima pagina
        //Na ultima pagina no mostra o boto prox e na primeira no mostra o ant
        lbtnAnt.Visible = !pgds.IsFirstPage;
        lbtnProx.Visible = !pgds.IsLastPage;

        //Seta a fonte de dados do repeater como o nosso objeto de paginao.
        rpt1.DataSource = pgds;
        rpt1.DataBind();

        ViewState["numeropaginas"] = numeropaginas;
        ViewState["pagina"] = pagina;
    }
    protected void UltimaPagina(object sender, CommandEventArgs e)
    {
        //Vai para a ultima pgina.
        ViewState["numeropaginas"] = pgds.PageCount;
        ViewState["pagina"] = pgds.PageCount - 1;
        numerop = totalpaginas - 1;
        FillDados();
    }
    protected void PrimeiraPagina(object sender, CommandEventArgs e)
    {
        //Vai para a primeira pgina
        ViewState["numeropaginas"] = totalpaginas;
        ViewState["pagina"] = 0;
        FillDados();
    }
    protected void Proximo(object sender, EventArgs e)
    {
        // Vai para a prxima pgina        
        pagina = Convert.ToInt16(ViewState["pagina"]);
        numeropaginas = Convert.ToInt32(ViewState["numeropaginas"]);

        pagina = pagina + 1;
        if (numeropaginas < pgds.PageCount && pagina > (totalpaginas - numerop - 1))
        {
            numeropaginas = numeropaginas + 1;
        }

        //se forem as ultimas paginas
        else if (pagina >= (pgds.PageCount - ((totalpaginas + 1) / 2)))
        {
            numerop = totalpaginas - (pgds.PageCount - pagina);
        }
        else
        {
            numerop = numerop + 1;
        }
        ViewState["pagina"] = pagina;
        ViewState["numeropaginas"] = numeropaginas;
        FillDados();
    }
    protected void Anterior(object sender, EventArgs e)
    {

        pagina = Convert.ToInt32(ViewState["pagina"]);
        numeropaginas = Convert.ToInt32(ViewState["numeropaginas"]);
        
        pagina  = pagina - 1;

        //Se no forem as primeiras nem as ultimas paginas
        if ((pagina < (pgds.PageCount - ((totalpaginas + 1) / 2))) && numeropaginas != totalpaginas)
        {
            numeropaginas = numeropaginas - 1;
        }

         //Se forem as ultimas paginas
        else if (pagina >= (pgds.PageCount - ((totalpaginas + 1) / 2)))
        {
            numerop = totalpaginas - (pgds.PageCount - pagina);
        }
        else
        {
            numerop = numerop - 1;
        }
        ViewState["pagina"] = pagina;
        ViewState["numeropaginas"] = numeropaginas;
        FillDados();
    }
    protected void Paginar(object sender, CommandEventArgs e)
    {
        pagina = Convert.ToInt32(ViewState["pagina"]);
        numeropaginas = Convert.ToInt32(ViewState["numeropaginas"]);

        pagina = Convert.ToInt32(e.CommandName);
        
        if (pagina < ((totalpaginas - 1) / 2))
        {
            numeropaginas = totalpaginas;
            int cont = 0;
            while (cont < ((totalpaginas - 1) / 2))
            {
                int p = pagina;
                if (p == cont)
                {
                    numerop = p;
                    break;
                }
                cont++;
            }
        }
        else if (pagina >= (pgds.PageCount - ((totalpaginas + 1) / 2)))
        {
            numerop = totalpaginas - (pgds.PageCount - pagina);
            if (pagina < pgds.PageCount)
            {
                numeropaginas = pagina + (pgds.PageCount - pagina);
            }
        }
        else
        {
            numeropaginas = pagina + ((totalpaginas + 1) / 2);
            numerop = 3;
        }
        ViewState["numeropaginas"] = numeropaginas;
        ViewState["pagina"] = pagina;
        FillDados();
    }
}
//                                   --- By Domingos Carreira De Paola 06/2009 ---

